package com.xxh.cloud.metadata.framework.modules.common.constant.enums;
/**
 * 标准结果分类(一级操作符)
 * */
public enum MetadataStandardResultTypeEnum {


    //==========结果值对应的明细操作符
    MSRT_Range("range","区间"),
    MSRT_Rise("rise","上升"),
    MSRT_Decline("decline","下降"),

    //normal 正常

    //========== 检验操作符
    MSRT_ResultValue("result_value","结果值"),
    MSRT_ResultTwoCategory("result_two_category","二分类结果"),
    MSRT_ResultNarrate("result_narrate","叙述结果"),

    //========== 检查操作符
    MSRT_ResultNarrate_ReportTip("result_narrate_tip","报告提示"), //叙述结果
    MSRT_ResultNarrate_ReportSee("result_narrate_see","报告所见"), //叙述结果


    MSRT_ResultNarrate_DiagnoseMain("result_narrate_diagnose_mina","主诊断(不限)"),  //叙述结果
    MSRT_ResultNarrate_DiagnoseMain_CB("result_narrate_diagnose_mina_cb","主诊断(初步诊断)"),
    MSRT_ResultNarrate_DiagnoseMain_MZ("result_narrate_diagnose_mina_mz","主诊断(门诊诊断)"),
    MSRT_ResultNarrate_DiagnoseMain_RY("result_narrate_diagnose_mina_ry","主诊断(入院诊断)"),
    MSRT_ResultNarrate_DiagnoseMain_CY("result_narrate_diagnose_mina_cy","主诊断(出院诊断)"),

    MSRT_ResultNarrate_DiagnoseMain_XZ("result_narrate_diagnose_mina_xz","主诊断(修正诊断)"),

    MSRT_ResultNarrate_DiagnoseMain_SW("result_narrate_diagnose_mina_sw","主诊断(死亡诊断)"),


    MSRT_ResultNarrate_DiagnosePre("result_narrate_diagnose_pre","预诊断(不限)"),  //叙述结果
    MSRT_ResultNarrate_DiagnosePre_CB("result_narrate_diagnose_pre_cb","预诊断(初步诊断)"),
    MSRT_ResultNarrate_DiagnosePre_MZ("result_narrate_diagnose_pre_mz","预诊断(门诊诊断)"),
    MSRT_ResultNarrate_DiagnosePre_RY("result_narrate_diagnose_pre_ry","预诊断(入院诊断)"),
    MSRT_ResultNarrate_DiagnosePre_CY("result_narrate_diagnose_pre_cy","预诊断(出院诊断)"),
    MSRT_ResultNarrate_DiagnosePre_XZ("result_narrate_diagnose_pre_xz","预诊断(修正诊断)"),
    MSRT_ResultNarrate_DiagnosePre_SW("result_narrate_diagnose_pre_sw","预诊断(死亡诊断)"),




    MSRT_ResultNarrate_History("result_history","历史"),  //历史
    MSRT_ResultNarrate_Current("result_current","当前"),  //当前


    MSRT_In_Dept("in_dept","转入"),  //历史
    MSRT_Out_Dept("out_dept","转出"),  //当前


    //===============
    MSRT_None("none","无操作符"),



    //======================

    MSRT_Scale_EQ("scale_eq","等于"),
    MSRT_Scale_NE("scale_ne","不等于"),

//    MSRT_Apply("apply","申请"),
//    MSRT_Use("use","完成"),

    //==========基础操作符
    MSRT_EQ("eq","等于"),
    MSRT_NE("ne","不等于"),
    MSRT_GT("gt","大于"),
    MSRT_GE("ge","大于等于"),
    MSRT_LT("lt","小于"),
    MSRT_LE("le","小于等于"),



    //=============
    EMR_Symptom("emr_symptom","症状"),





    ;

    private String code;
    private String msg;

    private MetadataStandardResultTypeEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }
    public String getCode() {
        return code;
    }
    public String getMsg() {
        return msg;
    }




}
