package com.xxh.cloud.metadata.framework.modules.base.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准元数据表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("md_metadata_info")
public class MetadataInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "业务类型(原始/标准)")
    private String bizType;


    @ApiModelProperty(value = "标准数据名称")
    private String name;


    @ApiModelProperty(value = "数据类型")
    private String dataType;


//    @ApiModelProperty(value = "数据内容类型")
//    private String dataContentType;


    @ApiModelProperty(value = "标准数据值配置")
    private String valConfig;


    @ApiModelProperty(value = "数据单位")
    private String unit;

    @ApiModelProperty(value = "数据结果分类")
    private String resultType;

    @ApiModelProperty(value = "参考内容")
    private String referenceContent;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
