package com.xxh.cloud.metadata.framework.modules.base.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 表字段模型表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("md_table_column_info")
public class TableColumnInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 所属表ID
     */
     @ApiModelProperty(value = "所属表ID")
      private String tableId;

    /**
     * 字段编号
     */
     @ApiModelProperty(value = "字段编号")
      private String code;

    /**
     * 字段名称
     */
     @ApiModelProperty(value = "字段名称")
      private String name;

    /**
     * 字段分组编号
     */
     @ApiModelProperty(value = "字段分组编号")
      private String groupCode;

    /**
     * 字段分组名称
     */
     @ApiModelProperty(value = "字段分组名称")
      private String groupName;

    /**
     * 字段类型
     */
     @ApiModelProperty(value = "字段类型")
      private String type;

    /**
     * 字段配置
     */
     @ApiModelProperty(value = "字段配置")
      private String config;

    /**
     * 元数据ID
     */
     @ApiModelProperty(value = "元数据ID")
      private String metadataId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 顺序
     */
     @ApiModelProperty(value = "顺序")
      private Integer orders;

//    /**
//     * 创建者
//     */
//     @ApiModelProperty(value = "创建者")
//      private String creator;
//
//    /**
//     * 创建时间
//     */
//     @ApiModelProperty(value = "创建时间")
//      private Date createDate;
//
//    /**
//     * 更新者
//     */
//     @ApiModelProperty(value = "更新者")
//      private String updater;
//
//    /**
//     * 更新时间
//     */
//     @ApiModelProperty(value = "更新时间")
//      private Date updateDate;


}
