package com.xxh.cloud.metadata.framework.modules.base.entity.dto;


import com.xxh.cloud.metadata.client.api.bean.bos.metadata.MetadataStandardValueDicModel;
import com.xxh.cloud.metadata.client.api.bean.bos.metadata.MetadataStandardValueNumModel;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardBizTypeEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.Map;

@Getter
@Setter
public class MetadataInfoSaveDTO {


    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "元数据编码",required = true)
    @NotEmpty(message = "元数据编码不能为空")
    private String id;



    @ApiModelProperty(value = "分类ID",required = true)
    @NotEmpty(message = "分类ID不能为空")
    private String categoryId;

    @ApiModelProperty(value = "元数据名称",required = true)
    @NotEmpty(message = "元数据名称不能为空")
    private String name;

    @ApiModelProperty(value = "业务类型(MetadataStandardBizTypeEnum)")
    private String bizType= MetadataStandardBizTypeEnum.Msbt_Standard.getCode();


    @ApiModelProperty(value = "数据类型(MetadataStandardTypeEnum)",required = true)
    @NotEmpty(message = "数据类型不能为空")
    private String dataType;


//    @ApiModelProperty(value = "数据内容类型")
//    private String dataContentType;


    @ApiModelProperty(value = "标准数据值配置")
    private Map<String,Object> valConfig;


    @ApiModelProperty(value = "数据结果分类[多]")
    private Map<String,String> resultType;

    @ApiModelProperty(value = "参考内容")
    private String referenceContent;

    @ApiModelProperty(value = "标准数据备注")
    private String remark;

    @ApiModelProperty(value = "标准数据单位")
    private String unit;

    @ApiModelProperty(value = "顺序")
    private Integer orders=0;



}
