package com.xxh.cloud.metadata.framework.modules.base.entity.dto;

import com.xxh.cloud.metadata.client.api.bean.bos.metadata.MetadataStandardValueDicModel;
import com.xxh.cloud.metadata.client.api.bean.bos.metadata.MetadataStandardValueNumModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.Map;

@Getter
@Setter
public class MetadataInfoUpdateDTO {


    @ApiModelProperty(value = "id" ,required = true)
    @NotEmpty(message = "ID不能为空")
    private String id;

    @ApiModelProperty(value = "元数据名称",required = true)
    @NotEmpty(message = "元数据名称不能为空")
    private String name;



    @ApiModelProperty(value = "数据类型(MetadataStandardTypeEnum)",required = true)
    @NotEmpty(message = "数据类型不能为空")
    private String dataType;

//    @ApiModelProperty(value = "数据内容类型")
//    private String dataContentType;


    @ApiModelProperty(value = "标准数据值配置")
    private Map<String,Object> valConfig;



    @ApiModelProperty(value = "标准数据备注")
    private String remark;

    @ApiModelProperty(value = "标准数据单位")
    private String unit;





    @ApiModelProperty(value = "数据结果分类[多]")
    private Map<String,String> resultType;

    @ApiModelProperty(value = "参考内容")
    private String referenceContent;


    @ApiModelProperty(value = "顺序")
    private Integer orders=0;




}
