package com.xxh.cloud.metadata.framework.modules.base.entity.vos;

import com.xxh.cloud.framework.common.param.bos.MetadataValueConfigBO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Getter
@Setter
public class MetadataInfoVO {


    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;

    @ApiModelProperty(value = "业务类型(原始/标准)")
    private String bizType;

    @ApiModelProperty(value = "标准数据名称")
    private String name;

    @ApiModelProperty(value = "数据类型")
    private String dataType;

    @ApiModelProperty(value = "数据内容类型")
    private String dataContentType;

    @ApiModelProperty(value = "标准数据单位")
    private String unit;


    @ApiModelProperty(value = "标准数据备注")
    private String remark;

    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "标准数据值配置")
    private Map<String,Object> valConfig;

    @ApiModelProperty(value = "数据结果分类[多]")
    private Map<String,String> resultType;

    @ApiModelProperty(value = "参考内容")
    private String referenceContent;

    @ApiModelProperty(value = "创建者")
    private String creator;

    @ApiModelProperty(value = "创建时间")
    private Date createDate;

    @ApiModelProperty(value = "更新者")
    private String updater;

    @ApiModelProperty(value = "更新时间")
    private Date updateDate;

    @ApiModelProperty(value = "标准数据值配置")
    private List<MetadataValueConfigBO> valConfigList;

    //=========================



    @ApiModelProperty(value = "分类名称")
    private String categoryName;

    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;

    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;


    @ApiModelProperty(value = "项目名称")
    private String projectName;


    public void addMetadataValueConfig(MetadataValueConfigBO item){
        if(this.valConfigList==null){
            this.valConfigList=new ArrayList<>();
        }
        if(item!=null){
            this.valConfigList.add(item);
        }
    }

}
