package com.xxh.cloud.metadata.framework.modules.base.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.MetadataCategoryInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.MetadataCategoryVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class MetadataCategoryHelper {

    public static String getMetadataStandardCategoryId(){
        return StrUtil.format("MSC{}", IdUtil.getSnowflake(6,1).nextIdStr());
    }

    public static MetadataCategoryVO getMetadataStandardCategoryVO(MetadataCategoryInfo entity){
        MetadataCategoryVO data=new MetadataCategoryVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }


    public static MetadataCategoryVO getMetadataStandardCategoryVO(MetadataCategoryInfo entity, Map<String, AdminUserBO> userMap){
        MetadataCategoryVO data=getMetadataStandardCategoryVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

        return data;
    }


}
