package com.xxh.cloud.metadata.framework.modules.base.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.TableCategoryInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableCategoryVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class TableCategoryHelper {

    public static String getTableCategoryId(){
        return StrUtil.format("TC{}", IdUtil.getSnowflake(6,2).nextIdStr());
    }

    public static TableCategoryVO getTableCategoryVO(TableCategoryInfo entity){
        TableCategoryVO data=new TableCategoryVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static TableCategoryVO getTableCategoryVO(TableCategoryInfo entity, Map<String, AdminUserBO> userMap){
        TableCategoryVO data=getTableCategoryVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        return data;
    }

}
