package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.MetadataCategoryInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.MetadataCategoryVO;
import com.xxh.cloud.metadata.framework.modules.base.biz.MetadataCategoryInfoBizService;
import com.xxh.cloud.metadata.framework.modules.base.helper.MetadataCategoryHelper;
import com.xxh.cloud.metadata.framework.modules.base.service.MetadataCategoryInfoService;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaDataCacheKeysHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.MetadataCategoryCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class MetadataCategoryCacheServiceImpl extends BasicCacheServiceImpl<MetadataCategoryVO> implements MetadataCategoryCacheService {


    @Autowired
    private MetadataCategoryInfoService metadataCategoryInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaDataCacheKeysHelper.getMetadataCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaDataCacheKeysHelper.getMetadataCategoryMainKey();
    }

    @Override
    public Class<MetadataCategoryVO> getJsonClazz() {
        return MetadataCategoryVO.class;
    }

    @Override
    public String getId(MetadataCategoryVO entity) {
        return entity.getId();
    }

    @Override
    public MetadataCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        MetadataCategoryInfo entity=metadataCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return MetadataCategoryHelper.getMetadataStandardCategoryVO(entity);
    }

    @Override
    public List<MetadataCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<MetadataCategoryInfo> list= metadataCategoryInfoService.list(
                new QueryWrapper<MetadataCategoryInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
                        .orderByDesc("orders")
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<MetadataCategoryVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(MetadataCategoryHelper.getMetadataStandardCategoryVO(item));
        });
        return data;
    }


}
