package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.MetadataInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.MetadataInfoVO;
import com.xxh.cloud.metadata.framework.modules.base.biz.MetadataInfoBizService;
import com.xxh.cloud.metadata.framework.modules.base.helper.MetadataInfoHelper;
import com.xxh.cloud.metadata.framework.modules.base.service.MetadataInfoService;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaDataCacheKeysHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.MetadataInfoCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class MetadataInfoCacheServiceImpl extends BasicCacheServiceImpl<MetadataInfoVO> implements MetadataInfoCacheService {

    @Autowired
    private MetadataInfoService metadataInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaDataCacheKeysHelper.getMetadataInfoKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaDataCacheKeysHelper.getMetadataInfoMainKey();
    }

    @Override
    public Class<MetadataInfoVO> getJsonClazz() {
        return MetadataInfoVO.class;
    }

    @Override
    public String getId(MetadataInfoVO entity) {
        return entity.getId();
    }

    @Override
    public MetadataInfoVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        MetadataInfo entity=metadataInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return MetadataInfoHelper.getMetadataInfoVO(entity);
    }

    @Override
    public List<MetadataInfoVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<MetadataInfo> list = metadataInfoService.list(new QueryWrapper<MetadataInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }

        List<MetadataInfoVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(MetadataInfoHelper.getMetadataInfoVO(item));
        });
        return data;
    }
}
