package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardDiseaseCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardDiseaseConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardDiseaseInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class StandardDiseaseCacheServiceImpl  extends BasicCacheServiceImpl<StandardDiseaseVO> implements StandardDiseaseCacheService {

    @Autowired
    private StandardDiseaseInfoService standardDiseaseInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardDiseaseCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardDiseaseCacheMainKey();
    }

    @Override
    public Class<StandardDiseaseVO> getJsonClazz() {
        return StandardDiseaseVO.class;
    }

    @Override
    public String getId(StandardDiseaseVO standardDiseaseVO) {
        return standardDiseaseVO.getId();
    }

    @Override
    public StandardDiseaseVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardDiseaseInfo entity=standardDiseaseInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardDiseaseConvert.getStandardDiseaseVO(entity);
    }

    @Override
    public List<StandardDiseaseVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardDiseaseInfo> list = standardDiseaseInfoService.list(new QueryWrapper<StandardDiseaseInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardDiseaseVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardDiseaseConvert.getStandardDiseaseVO(item));
        });
        return data;
    }


}
