package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardDiseaseSystemCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseSystemVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseSystemInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardDiseaseSystemConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardDiseaseSystemInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardDiseaseSystemCacheServiceImpl extends BasicCacheServiceImpl<StandardDiseaseSystemVO> implements StandardDiseaseSystemCacheService {


    @Autowired
    private StandardDiseaseSystemInfoService standardDiseaseSystemInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardDiseaseSystemCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardDiseaseSystemCacheMainKey();
    }

    @Override
    public Class<StandardDiseaseSystemVO> getJsonClazz() {
        return StandardDiseaseSystemVO.class;
    }

    @Override
    public String getId(StandardDiseaseSystemVO standardDiseaseSystemVO) {
        return standardDiseaseSystemVO.getId();
    }

    @Override
    public StandardDiseaseSystemVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardDiseaseSystemInfo entity=standardDiseaseSystemInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardDiseaseSystemConvert.getStandardDiseaseSystemVO(entity);
    }

    @Override
    public List<StandardDiseaseSystemVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardDiseaseSystemInfo> list = standardDiseaseSystemInfoService.list(new QueryWrapper<StandardDiseaseSystemInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardDiseaseSystemVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardDiseaseSystemConvert.getStandardDiseaseSystemVO(item));
        });
        return data;
    }
}
