package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardEventCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardEventVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardEventInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardEventConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardEventInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardEventCacheServiceImpl extends BasicCacheServiceImpl<StandardEventVO> implements StandardEventCacheService {

    @Autowired
    private StandardEventInfoService standardEventInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardEventCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardEventCacheMainKey();
    }

    @Override
    public Class<StandardEventVO> getJsonClazz() {
        return StandardEventVO.class;
    }

    @Override
    public String getId(StandardEventVO entity) {
        return entity.getId();
    }

    @Override
    public StandardEventVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardEventInfo entity= standardEventInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardEventConvert.getStandardEventVO(entity);
    }

    @Override
    public List<StandardEventVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardEventInfo> list = standardEventInfoService.list(new QueryWrapper<StandardEventInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardEventVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardEventConvert.getStandardEventVO(item));
        });
        return data;
    }
}
