package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardExamineProjectCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardExamineProjectVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardExamineProjectInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardExamineProjectConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardExamineProjectInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardExamineProjectCacheServiceImpl extends BasicCacheServiceImpl<StandardExamineProjectVO> implements StandardExamineProjectCacheService {


    @Autowired
    private StandardExamineProjectInfoService standardExamineProjectInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardExamineProjectCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardExamineProjectCacheMainKey();
    }

    @Override
    public Class<StandardExamineProjectVO> getJsonClazz() {
        return StandardExamineProjectVO.class;
    }

    @Override
    public String getId(StandardExamineProjectVO standardExamineProjectVO) {
        return standardExamineProjectVO.getId();
    }

    @Override
    public StandardExamineProjectVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardExamineProjectInfo entity=standardExamineProjectInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardExamineProjectConvert.getStandardExamineProjectVO(entity);
    }

    @Override
    public List<StandardExamineProjectVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardExamineProjectInfo> list = standardExamineProjectInfoService.list(new QueryWrapper<StandardExamineProjectInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)

        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardExamineProjectVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardExamineProjectConvert.getStandardExamineProjectVO(item));
        });
        return data;
    }
}
