package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardKeywordsCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardKeywordsVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardKeywordsInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardKeywordsConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardKeywordsInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardKeywordsCacheServiceImpl  extends BasicCacheServiceImpl<StandardKeywordsVO>  implements StandardKeywordsCacheService {


    @Autowired
    private StandardKeywordsInfoService standardKeywordsInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardKeywordsCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardKeywordsCacheMainKey();
    }

    @Override
    public Class<StandardKeywordsVO> getJsonClazz() {
        return StandardKeywordsVO.class;
    }

    @Override
    public String getId(StandardKeywordsVO entity) {
        return entity.getId();
    }

    @Override
    public List<StandardKeywordsVO> getListAllByCache() {
        return null;
    }

    

    @Override
    public StandardKeywordsVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardKeywordsInfo entity= standardKeywordsInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardKeywordsConvert.getStandardKeywordsVO(entity);
    }

    @Override
    public List<StandardKeywordsVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardKeywordsInfo> list = standardKeywordsInfoService.list(new QueryWrapper<StandardKeywordsInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardKeywordsVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardKeywordsConvert.getStandardKeywordsVO(item));
        });
        return data;
    }



}
