package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryGroupCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryGroupVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryGroupInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardLaboratoryConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardLaboratoryGroupInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardLaboratoryGroupCacheServiceImpl extends BasicCacheServiceImpl<StandardLaboratoryGroupVO> implements StandardLaboratoryGroupCacheService {


    @Autowired
    private StandardLaboratoryGroupInfoService standardLaboratoryGroupInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryGroupCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryGroupCacheMainKey();
    }

    @Override
    public Class<StandardLaboratoryGroupVO> getJsonClazz() {
        return StandardLaboratoryGroupVO.class;
    }

    @Override
    public String getId(StandardLaboratoryGroupVO standardLaboratoryGroupVO) {
        return standardLaboratoryGroupVO.getId();
    }

    @Override
    public StandardLaboratoryGroupVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryGroupInfo entity=standardLaboratoryGroupInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardLaboratoryConvert.getStandardLaboratoryGroupVO(entity);
    }

    @Override
    public List<StandardLaboratoryGroupVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardLaboratoryGroupInfo> list = standardLaboratoryGroupInfoService.list(new QueryWrapper<StandardLaboratoryGroupInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardLaboratoryGroupVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardLaboratoryConvert.getStandardLaboratoryGroupVO(item));
        });
        return data;
    }
}
