package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryProjectCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryProjectVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryProjectInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardLaboratoryConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardLaboratoryProjectInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardLaboratoryProjectCacheServiceImpl extends BasicCacheServiceImpl<StandardLaboratoryProjectVO> implements StandardLaboratoryProjectCacheService {

    @Autowired
    private StandardLaboratoryProjectInfoService standardLaboratoryProjectInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryProjectCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryProjectCacheMainKey();
    }

    @Override
    public Class<StandardLaboratoryProjectVO> getJsonClazz() {
        return StandardLaboratoryProjectVO.class;
    }

    @Override
    public String getId(StandardLaboratoryProjectVO standardLaboratoryProjectVO) {
        return standardLaboratoryProjectVO.getId();
    }

    @Override
    public StandardLaboratoryProjectVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryProjectInfo entity=standardLaboratoryProjectInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardLaboratoryConvert.getStandardLaboratoryProjectVO(entity);
    }

    @Override
    public List<StandardLaboratoryProjectVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardLaboratoryProjectInfo> list = standardLaboratoryProjectInfoService.list(new QueryWrapper<StandardLaboratoryProjectInfo>()
                .eq("rows_status",YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardLaboratoryProjectVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add( StandardLaboratoryConvert.getStandardLaboratoryProjectVO(item));
        });
        return data;
    }
}
