package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryTypeCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryTypeVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryTypeInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardLaboratoryConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardLaboratoryTypeInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class StandardLaboratoryTypeCacheServiceImpl extends BasicCacheServiceImpl<StandardLaboratoryTypeVO>  implements StandardLaboratoryTypeCacheService {

    @Autowired
    private StandardLaboratoryTypeInfoService standardLaboratoryTypeInfoService;



    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryTypeCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardLaboratoryTypeCacheMainKey();
    }

    @Override
    public Class<StandardLaboratoryTypeVO> getJsonClazz() {
        return StandardLaboratoryTypeVO.class;
    }

    @Override
    public String getId(StandardLaboratoryTypeVO standardLaboratoryTypeVO) {
        return standardLaboratoryTypeVO.getId();
    }

    @Override
    public StandardLaboratoryTypeVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryTypeInfo entity=standardLaboratoryTypeInfoService.getById(id);
        if(entity==null){
            return null;
        }
        return StandardLaboratoryConvert.getStandardLaboratoryTypeVO(entity);
    }

    @Override
    public List<StandardLaboratoryTypeVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardLaboratoryTypeInfo> list = standardLaboratoryTypeInfoService.listByIds(ids);
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardLaboratoryTypeVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardLaboratoryConvert.getStandardLaboratoryTypeVO(entity));
        });
        return data;
    }
}
