package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardMedicantCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardMedicantVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardMedicantInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardMedicantConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardMedicantInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardMedicantCacheServiceImpl extends BasicCacheServiceImpl<StandardMedicantVO> implements StandardMedicantCacheService {

    @Autowired
    private StandardMedicantInfoService standardMedicantInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardMedicantCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardMedicantCacheMainKey();
    }

    @Override
    public Class<StandardMedicantVO> getJsonClazz() {
        return StandardMedicantVO.class;
    }

    @Override
    public String getId(StandardMedicantVO standardMedicantVO) {
        return standardMedicantVO.getId();
    }

    @Override
    public StandardMedicantVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardMedicantInfo entity=standardMedicantInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
           return null;
        }
        return StandardMedicantConvert.getStandardMedicantVO(entity);
    }

    @Override
    public List<StandardMedicantVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardMedicantInfo> list = standardMedicantInfoService.list(
                new QueryWrapper<StandardMedicantInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardMedicantVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardMedicantConvert.getStandardMedicantVO(entity));
        });
        return data;
    }
}
