package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardMedicantDrugRelCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardMedicantDrugRelVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardMedicantDrugRel;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardMedicantConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardMedicantDrugRelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardMedicantDrugRelCacheServiceImpl extends BasicCacheServiceImpl<StandardMedicantDrugRelVO> implements StandardMedicantDrugRelCacheService {

    @Autowired
    private StandardMedicantDrugRelService standardMedicantDrugRelService;


    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardMedicantCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardMedicantCacheMainKey();
    }

    @Override
    public Class<StandardMedicantDrugRelVO> getJsonClazz() {
        return StandardMedicantDrugRelVO.class;
    }

    @Override
    public String getId(StandardMedicantDrugRelVO standardMedicantVO) {
        return standardMedicantVO.getId();
    }

    @Override
    public StandardMedicantDrugRelVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardMedicantDrugRel entity=standardMedicantDrugRelService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
           return null;
        }
        return StandardMedicantConvert.getStandardMedicantDrugRelVO(entity);
    }

    @Override
    public List<StandardMedicantDrugRelVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardMedicantDrugRel> list = standardMedicantDrugRelService.list(
                new QueryWrapper<StandardMedicantDrugRel>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardMedicantDrugRelVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardMedicantConvert.getStandardMedicantDrugRelVO(entity));
        });
        return data;
    }
}
