package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardOperationCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardOperationVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardOperationInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardOperationConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardOperationInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardOperationCacheServiceImpl extends BasicCacheServiceImpl<StandardOperationVO> implements StandardOperationCacheService {

    @Autowired
    private StandardOperationInfoService standardOperationInfoService;

    @Override
    public String getCacheKey(String id) {
        return  MetaStandardCacheKeyHelper.getStandardOperationCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return  MetaStandardCacheKeyHelper.getStandardOperationCacheMainKey();
    }

    @Override
    public Class<StandardOperationVO> getJsonClazz() {
        return StandardOperationVO.class;
    }

    @Override
    public String getId(StandardOperationVO standardOperationVO) {
        return standardOperationVO.getId();
    }

    @Override
    public StandardOperationVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardOperationInfo entity=standardOperationInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardOperationConvert.getStandardOperationVO(entity);
    }

    @Override
    public List<StandardOperationVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardOperationInfo> list = standardOperationInfoService.list(new QueryWrapper<StandardOperationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardOperationVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardOperationConvert.getStandardOperationVO(entity));
        });
        return data;
    }
}
