package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardSampleCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSampleVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardSampleInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardSampleConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardSampleInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class StandardSampleCacheServiceImpl extends BasicCacheServiceImpl<StandardSampleVO>  implements StandardSampleCacheService {

    @Autowired
    private StandardSampleInfoService standardSampleInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardSampleCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardSampleCacheMainKey();
    }

    @Override
    public Class<StandardSampleVO> getJsonClazz() {
        return StandardSampleVO.class;
    }

    @Override
    public String getId(StandardSampleVO standardSampleVO) {
        return standardSampleVO.getId();
    }

    @Override
    public StandardSampleVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardSampleInfo entity=standardSampleInfoService.getById(id);
        if(entity==null){
            return null;
        }
        return StandardSampleConvert.getStandardSampleVO(entity);
    }

    @Override
    public List<StandardSampleVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardSampleInfo> list = standardSampleInfoService.listByIds(ids);
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardSampleVO> data=new ArrayList<>();
        list.forEach(entity->{
            if(YN.YES.getCode().equals(entity.getRowsStatus())){
                data.add(StandardSampleConvert.getStandardSampleVO(entity));
            }
        });
        return data;
    }
}
