package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardSymptomCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSymptomVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardSymptomInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardSymptomConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardSymptomInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardSymptomCacheServiceImpl extends BasicCacheServiceImpl<StandardSymptomVO> implements StandardSymptomCacheService {

    @Autowired
    private StandardSymptomInfoService standardSymptomInfoService;

    @Override
    public String getCacheKey(String id) {
        return MetaStandardCacheKeyHelper.getStandardSymptomCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardSymptomCacheMainKey();
    }

    @Override
    public Class<StandardSymptomVO> getJsonClazz() {
        return StandardSymptomVO.class;
    }

    @Override
    public String getId(StandardSymptomVO standardSymptomVO) {
        return standardSymptomVO.getId();
    }

    @Override
    public StandardSymptomVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardSymptomInfo entity=standardSymptomInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardSymptomConvert.getStandardSymptomVO(entity);
    }

    @Override
    public List<StandardSymptomVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardSymptomInfo> list = standardSymptomInfoService.list(new QueryWrapper<StandardSymptomInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardSymptomVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardSymptomConvert.getStandardSymptomVO(entity));
        });
        return data;
    }
}
