package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaStandardCacheKeyHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardUnitCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardUnitVO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardUnitInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardUnitConvert;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardUnitInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardUnitCacheServiceImpl  extends BasicCacheServiceImpl<StandardUnitVO> implements StandardUnitCacheService {

    @Autowired
    private StandardUnitInfoService standardUnitInfoService;

    @Override
    public String getCacheKey(String id) {
         return MetaStandardCacheKeyHelper.getStandardUnitCacheKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaStandardCacheKeyHelper.getStandardUnitCacheMainKey();
    }

    @Override
    public Class<StandardUnitVO> getJsonClazz() {
        return StandardUnitVO.class;
    }

    @Override
    public String getId(StandardUnitVO standardUnitVO) {
        return standardUnitVO.getId();
    }

    @Override
    public StandardUnitVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardUnitInfo entity=standardUnitInfoService.getById(id);
        if(entity==null){
            return null;
        }
        return StandardUnitConvert.getStandardUnitVO(entity);
    }

    @Override
    public List<StandardUnitVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }

        List<StandardUnitInfo> list =standardUnitInfoService.listByIds(ids);
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardUnitVO> data=new ArrayList<>();
        list.forEach(entity->{
            data.add(StandardUnitConvert.getStandardUnitVO(entity));
        });
        return data;
    }
}
