package com.xxh.cloud.metadata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.TableCategoryInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableCategoryVO;
import com.xxh.cloud.metadata.framework.modules.base.helper.TableCategoryHelper;
import com.xxh.cloud.metadata.framework.modules.base.service.TableCategoryInfoService;
import com.xxh.cloud.metadata.framework.modules.cache.helper.MetaDataCacheKeysHelper;
import com.xxh.cloud.metadata.framework.modules.cache.service.TableCategoryCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class TableCategoryCacheServiceImpl extends BasicCacheServiceImpl<TableCategoryVO> implements TableCategoryCacheService {


    @Autowired
    private TableCategoryInfoService tableCategoryInfoService;


    @Override
    public String getCacheKey(String id) {
        return MetaDataCacheKeysHelper.getTableCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return MetaDataCacheKeysHelper.getTableCategoryMainKey();
    }

    @Override
    public Class<TableCategoryVO> getJsonClazz() {
        return TableCategoryVO.class;
    }

    @Override
    public String getId(TableCategoryVO entity) {
        return entity.getId();
    }

    @Override
    public TableCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        TableCategoryInfo entity=tableCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return TableCategoryHelper.getTableCategoryVO(entity);
    }

    @Override
    public List<TableCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<TableCategoryInfo> list= tableCategoryInfoService.list(
                new QueryWrapper<TableCategoryInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<TableCategoryVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(TableCategoryHelper.getTableCategoryVO(item));
        });
        return data;
    }
}
