package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.MetadataCategoryClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.meta.MetadataCategoryBO;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.MetadataCategoryVO;
import com.xxh.cloud.metadata.framework.modules.cache.service.MetadataCategoryCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.MetadataClientConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class MetadataCategoryClientServiceImpl implements MetadataCategoryClientService {

    @Autowired
    private MetadataCategoryCacheService metadataCategoryCacheService;

    @Override
    public MetadataCategoryBO getMetadataCategoryById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        MetadataCategoryVO metadataCategory= metadataCategoryCacheService.getById(id);
        return MetadataClientConvert.getMetadataCategoryBO(metadataCategory);
    }

    @Override
    public List<MetadataCategoryBO> getMetadataCategoryListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<MetadataCategoryVO> list= metadataCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(MetadataClientConvert::getMetadataCategoryBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, MetadataCategoryBO> getMetadataCategoryMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<MetadataCategoryVO> list= metadataCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(MetadataCategoryVO::getId, MetadataClientConvert::getMetadataCategoryBO)));
    }


}
