package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.metadata.client.api.StandardDiseaseClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardDiseaseCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseInfo;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardDiseaseInfoService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.helper.StandardDiseaseConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardDiseaseClientServiceImpl implements StandardDiseaseClientService {

    @Autowired
    private StandardDiseaseCacheService standardDiseaseCacheService;

    @Autowired
    private StandardDiseaseInfoService standardDiseaseInfoService;

    @Override
    public StandardDiseaseBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardDiseaseVO entity= standardDiseaseCacheService.getById(id);
        return StandardClientConvert.getStandardDiseaseBO(entity);
    }

    @Override
    public List<StandardDiseaseBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardDiseaseVO> list = standardDiseaseCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardDiseaseBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardDiseaseBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardDiseaseVO> list = standardDiseaseCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardDiseaseVO::getId, StandardClientConvert::getStandardDiseaseBO)));
    }

//    @Override
//    public List<StandardDiseaseBO> getAllListIfNoIds(Collection<String> ids) {
//
//        List<StandardDiseaseVO> list = null;
//        if (CollUtil.isNotEmpty(ids)) {
//            list = standardDiseaseCacheService.getListByIds(ids);
//        } else {
//            List<StandardDiseaseInfo> entityList = standardDiseaseInfoService.list(new QueryWrapper<StandardDiseaseInfo>()
//                    .eq("rows_status", YN.YES.getCode())
//            );
//            if (CollUtil.isNotEmpty(entityList)) {
//                list = entityList.stream().map(StandardDiseaseConvert::getStandardDiseaseVO).collect(Collectors.toList());
//            }
//        }
//        if (CollUtil.isEmpty(list)) {
//            return new ArrayList<>();
//        }
//        return list.stream().map(StandardClientConvert::getStandardDiseaseBO).collect(Collectors.toList());
//
//    }


}
