package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardDiseaseSystemClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseSystemBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardDiseaseSystemCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseSystemVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardDiseaseSystemClientServiceImpl implements StandardDiseaseSystemClientService {

    @Autowired
    private StandardDiseaseSystemCacheService standardDiseaseSystemCacheService;


    @Override
    public StandardDiseaseSystemBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardDiseaseSystemVO entity= standardDiseaseSystemCacheService.getById(id);
        return StandardClientConvert.getStandardDiseaseSystemBO(entity);
    }

    @Override
    public List<StandardDiseaseSystemBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardDiseaseSystemVO> list = standardDiseaseSystemCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardDiseaseSystemBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardDiseaseSystemBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardDiseaseSystemVO> list = standardDiseaseSystemCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardDiseaseSystemVO::getId, StandardClientConvert::getStandardDiseaseSystemBO)));
    }
}
