package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardEventClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardEventBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardEventCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardEventVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardEventClientServiceImpl implements StandardEventClientService {

    @Autowired
    private StandardEventCacheService standardEventCacheService;


    @Override
    public StandardEventBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardEventVO entity= standardEventCacheService.getById(id);
        return StandardClientConvert.getStandardEventBO(entity);
    }

    @Override
    public List<StandardEventBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardEventVO> list = standardEventCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardEventBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardEventBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardEventVO> list = standardEventCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardEventVO::getId, StandardClientConvert::getStandardEventBO)));
    }
}
