package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardExamineProjectClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardExamineProjectBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardExamineProjectCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardExamineProjectVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardExamineProjectClientServiceImpl implements StandardExamineProjectClientService {

    @Autowired
    private StandardExamineProjectCacheService standardExamineProjectCacheService;


    @Override
    public StandardExamineProjectBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardExamineProjectVO entity= standardExamineProjectCacheService.getById(id);
        return StandardClientConvert.getStandardExamineProjectBO(entity);
    }

    @Override
    public List<StandardExamineProjectBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardExamineProjectVO> list = standardExamineProjectCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardExamineProjectBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardExamineProjectBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardExamineProjectVO> list = standardExamineProjectCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardExamineProjectVO::getId, StandardClientConvert::getStandardExamineProjectBO)));

    }
}
