package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardKeywordsClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardKeywordsBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardKeywordsCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardKeywordsVO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Log4j2
@Service
public class StandardKeywordsClientServiceImpl implements StandardKeywordsClientService {

    @Autowired
    private StandardKeywordsCacheService standardKeywordsCacheService;

    @Override
    public StandardKeywordsBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardKeywordsVO entity= standardKeywordsCacheService.getById(id);
        return StandardClientConvert.getStandardKeywordsBO(entity);
    }

    @Override
    public List<StandardKeywordsBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardKeywordsVO> list = standardKeywordsCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardKeywordsBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardKeywordsBO> getMap(Collection<String> ids) {

        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardKeywordsVO> list = standardKeywordsCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardKeywordsVO::getId, StandardClientConvert::getStandardKeywordsBO)));

    }

    @Override
    public List<StandardKeywordsBO> getListAll() {
        //todo:
        return null;
    }


}
