package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardLaboratoryGroupClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardLaboratoryGroupBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryGroupCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryGroupVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardLaboratoryGroupClientServiceImpl implements StandardLaboratoryGroupClientService {

    @Autowired
    private StandardLaboratoryGroupCacheService standardLaboratoryGroupCacheService;

    @Override
    public StandardLaboratoryGroupBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryGroupVO entity= standardLaboratoryGroupCacheService.getById(id);
        return StandardClientConvert.getStandardLaboratoryGroupBO(entity);
    }

    @Override
    public List<StandardLaboratoryGroupBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardLaboratoryGroupVO> list = standardLaboratoryGroupCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardLaboratoryGroupBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardLaboratoryGroupBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardLaboratoryGroupVO> list = standardLaboratoryGroupCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardLaboratoryGroupVO::getId, StandardClientConvert::getStandardLaboratoryGroupBO)));
    }


}
