package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardLaboratoryProjectClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardLaboratoryProjectBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryProjectCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryProjectVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardLaboratoryProjectClientServiceImpl implements StandardLaboratoryProjectClientService {

    @Autowired
    private StandardLaboratoryProjectCacheService standardLaboratoryProjectCacheService;


    @Override
    public StandardLaboratoryProjectBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryProjectVO entity= standardLaboratoryProjectCacheService.getById(id);
        return StandardClientConvert.getStandardLaboratoryProjectBO(entity);
    }

    @Override
    public List<StandardLaboratoryProjectBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardLaboratoryProjectVO> list = standardLaboratoryProjectCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardLaboratoryProjectBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardLaboratoryProjectBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardLaboratoryProjectVO> list = standardLaboratoryProjectCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardLaboratoryProjectVO::getId, StandardClientConvert::getStandardLaboratoryProjectBO)));
    }


}
