package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardLaboratoryTypeClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardLaboratoryTypeBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardLaboratoryTypeCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryTypeVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardLaboratoryTypeClientServiceImpl implements StandardLaboratoryTypeClientService {

    @Autowired
    private StandardLaboratoryTypeCacheService standardLaboratoryTypeCacheService;


    @Override
    public StandardLaboratoryTypeBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLaboratoryTypeVO entity= standardLaboratoryTypeCacheService.getById(id);
        return StandardClientConvert.getStandardLaboratoryTypeBO(entity);
    }

    @Override
    public List<StandardLaboratoryTypeBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardLaboratoryTypeVO> list = standardLaboratoryTypeCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardLaboratoryTypeBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardLaboratoryTypeBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardLaboratoryTypeVO> list = standardLaboratoryTypeCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardLaboratoryTypeVO::getId, StandardClientConvert::getStandardLaboratoryTypeBO)));
    }
}
