package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardMedicantClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardMedicantBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardMedicantCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardMedicantVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardMedicantClientServiceImpl implements StandardMedicantClientService {

    @Autowired
    private StandardMedicantCacheService standardMedicantCacheService;


    @Override
    public StandardMedicantBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardMedicantVO entity = standardMedicantCacheService.getById(id);
        return StandardClientConvert.getStandardMedicantBO(entity);
    }

    @Override
    public List<StandardMedicantBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardMedicantVO> list = standardMedicantCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardMedicantBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardMedicantBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardMedicantVO> list = standardMedicantCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardMedicantVO::getId, StandardClientConvert::getStandardMedicantBO)));

    }
}
