package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardOperationClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardOperationBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardOperationCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardOperationVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardOperationClientServiceImpl implements StandardOperationClientService {

    @Autowired
    private StandardOperationCacheService standardOperationCacheService;

    @Override
    public StandardOperationBO getById(String id) {

        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardOperationVO entity= standardOperationCacheService.getById(id);
        return StandardClientConvert.getStandardOperationBO(entity);
    }

    @Override
    public List<StandardOperationBO> getList(Collection<String> ids) {

        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardOperationVO> list = standardOperationCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardOperationBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardOperationBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardOperationVO> list = standardOperationCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardOperationVO::getId, StandardClientConvert::getStandardOperationBO)));

    }
}
