package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardSampleClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardSampleBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardSampleCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSampleVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardSampleClientServiceImpl implements StandardSampleClientService {


    @Autowired
    private StandardSampleCacheService standardSampleCacheService;


    @Override
    public StandardSampleBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardSampleVO entity= standardSampleCacheService.getById(id);
        return StandardClientConvert.getStandardSampleBO(entity);
    }

    @Override
    public List<StandardSampleBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardSampleVO> list = standardSampleCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardSampleBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardSampleBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardSampleVO> list = standardSampleCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardSampleVO::getId, StandardClientConvert::getStandardSampleBO)));

    }
}
