package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardSymptomClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardSymptomBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardSymptomCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSymptomVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardSymptomClientServiceImpl implements StandardSymptomClientService {

    @Autowired
    private StandardSymptomCacheService standardSymptomCacheService;

    @Override
    public StandardSymptomBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardSymptomVO entity= standardSymptomCacheService.getById(id);
        return StandardClientConvert.getStandardSymptomBO(entity);
    }

    @Override
    public List<StandardSymptomBO> getList(Collection<String> ids) {

        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardSymptomVO> list = standardSymptomCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardSymptomBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardSymptomBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardSymptomVO> list = standardSymptomCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardSymptomVO::getId, StandardClientConvert::getStandardSymptomBO)));

    }
}
