package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.StandardUnitClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardUnitBO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardUnitCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.StandardClientConvert;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardUnitVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StandardUnitClientServiceImpl implements StandardUnitClientService {

    @Autowired
    private StandardUnitCacheService standardUnitCacheService;

    @Override
    public StandardUnitBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardUnitVO entity= standardUnitCacheService.getById(id);
        return StandardClientConvert.getStandardUnitBO(entity);
    }

    @Override
    public List<StandardUnitBO> getList(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardUnitVO> list = standardUnitCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(StandardClientConvert::getStandardUnitBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, StandardUnitBO> getMap(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardUnitVO> list = standardUnitCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(StandardUnitVO::getId, StandardClientConvert::getStandardUnitBO)));
    }
}
