package com.xxh.cloud.metadata.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.client.api.TableCategoryClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.table.TableCategoryBO;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableCategoryVO;
import com.xxh.cloud.metadata.framework.modules.cache.service.TableCategoryCacheService;
import com.xxh.cloud.metadata.framework.modules.client.helper.TableCategoryClientConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class TableCategoryClientServiceImpl implements TableCategoryClientService {

    @Autowired
    private TableCategoryCacheService tableCategoryCacheService;


    @Override
    public TableCategoryBO getTableCategoryById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        TableCategoryVO tableCategory= tableCategoryCacheService.getById(id);
        return TableCategoryClientConvert.getTableCategoryBO(tableCategory);
    }

    @Override
    public List<TableCategoryBO> getTableCategoryListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<TableCategoryVO> list= tableCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(TableCategoryClientConvert::getTableCategoryBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, TableCategoryBO> getTableCategoryMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<TableCategoryVO> list= tableCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(TableCategoryVO::getId, TableCategoryClientConvert::getTableCategoryBO)));
    }



}
