package com.xxh.cloud.metadata.framework.modules.script.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class EntityDDLCreateDTO {

    @ApiModelProperty(value = "数据源分类",required = true)
    @NotEmpty(message = "数据源分类不能为空")
    private String dataSourceType;


    @ApiModelProperty(value = "库编号",required = true)
    @NotEmpty(message = "库编号不能为空")
    private String database;


    @ApiModelProperty(value = "表编号",required = true)
    @NotEmpty(message = "表编号不能为空")
    private String tableCode;

    @ApiModelProperty(value = "表名称",required = true)
    @NotEmpty(message = "表名称不能为空")
    private String tableName;


    @ApiModelProperty(value = "属性列表",required = true)
    @NotNull(message = "属性列表不能为空")
    private List<EntityDDLCreatePropertyDTO> props;


    public void addProp(EntityDDLCreatePropertyDTO item){
        if(this.props==null){
            this.props=new ArrayList<>();
        }
        if(item!=null){
            this.props.add(item);
        }
    }





}
