package com.xxh.cloud.metadata.framework.modules.script.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.constant.DataSourceTypeEnum;
import com.xxh.cloud.metadata.framework.modules.script.bean.vos.TableEntityPropertyVO;
import com.xxh.cloud.metadata.framework.modules.script.bean.vos.TableEntityVO;
import com.xxh.cloud.metadata.framework.modules.script.convert.DTConvertFactory;
import com.xxh.cloud.metadata.framework.modules.script.convert.TypeConvertApi;
import com.xxh.cloud.metadata.framework.modules.script.mapper.SqlDDLMapper;
import com.xxh.cloud.metadata.framework.modules.script.service.EntitySchemaApiService;
import com.xxh.cloud.metadata.framework.modules.script.sql.ddl.SqlDDLUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class EntitySchemaApiServiceImpl implements EntitySchemaApiService {


    @Autowired
    private SqlDDLMapper sqlDDLMapper;



    @Override
    public List<TableEntityVO> getTableList(DataSourceTypeEnum dataSourceType, String database) {
        String sql= SqlDDLUtils.getTabel2DBSQL(dataSourceType,database);
        List<TableEntityVO> list = sqlDDLMapper.entityList(sql);
        return list;
    }

    @Override
    public List<TableEntityVO> getTableLikeList(DataSourceTypeEnum dataSourceType, String database, String likeTableCode) {
        String sql= SqlDDLUtils.getTabel2DBLikeSQL(dataSourceType,database,likeTableCode);
        System.out.println(" +++++ " + sql);
        List<TableEntityVO> list = sqlDDLMapper.entityList(sql);
        return list;
    }

    @Override
    public TableEntityVO getTableInfo(DataSourceTypeEnum dataSourceType, String database, String tableCode) {
        String sql= SqlDDLUtils.getTabel2DBSQL(dataSourceType,database,tableCode);
        TableEntityVO entityModel= sqlDDLMapper.getEntityObj(sql);
        return entityModel;
    }

    @Override
    public List<TableEntityPropertyVO> getTableColumns(DataSourceTypeEnum dataSourceType, String database, String tableCode) {
        String sql= SqlDDLUtils.getColumn2TableSQL(dataSourceType,database,tableCode);
        List<TableEntityPropertyVO> list= sqlDDLMapper.entityPropList(sql);

        if(CollUtil.isNotEmpty(list)){
            TypeConvertApi convert= DTConvertFactory.getConvertTypeFactory(dataSourceType);
            for(TableEntityPropertyVO propertyVO:list){
                propertyVO.setEntityDataType(convert.getEntityDataType(propertyVO.getType()));
            }
        }
        return list;
    }
}
