package com.xxh.cloud.metadata.framework.modules.script.sql.operate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean.InsertBean;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean.JoinBean;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.script.SqlConvertByType;

import java.util.ArrayList;
import java.util.List;

public class InsertSqlWrapper implements ISqlWrapper{



    private List<InsertBean> insert;
    private String tableName;

    public InsertSqlWrapper tableName(String tableName){
        this.tableName=tableName;
        return this;
    }

    public InsertSqlWrapper insert(List<InsertBean> insert){
        this.insert=insert;
        return this;
    }

    public InsertSqlWrapper insert(InsertBean insertBean){
        if(this.insert==null){
            this.insert=new ArrayList<>();
        }
        if(insertBean!=null){
            this.insert.add(insertBean);
        }
        return this;
    }


    private void check() throws BusinessException {
        if(StrUtil.isEmpty(this.tableName)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"SQL错误:表名不能为空");
        }
        if(CollUtil.isEmpty(this.insert)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"SQL错误:insert字段和值不能为空");
        }
    }


    @Override
    public String getSqlSegment(){
        this.check();
        boolean isOne=true;
        StringBuilder cols=new StringBuilder();
        StringBuilder vals=new StringBuilder();
        for(InsertBean entity:this.insert){
            if(StrUtil.isNotEmpty(entity.getV())){
                if(isOne){
                    isOne=false;
                }else {
                    cols.append(" , ");
                    vals.append(" , ");
                }
                cols.append(entity.getP());
                vals.append(SqlConvertByType.convert(entity.getT(),entity.getV()));
            }
        }
        StringBuilder sql=new StringBuilder();
        sql.append("INSERT INTO ").append(this.tableName);
        sql.append(" ( ").append(cols.toString()).append(" ) ");
        sql.append(" VALUES ( ").append(vals.toString()).append(" ); ");
        return  sql.toString();
    }



}
