package com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean;

import com.xxh.cloud.metadata.framework.modules.common.constant.enums.ConditionOp;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.constant.ApiInputValTypeEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
public class WhereItemBean {


    @ApiModelProperty(value = "条件分类[WhereSDEnum]")
    private String sd= ApiInputValTypeEnum.StaticWhere.getCode();

    @ApiModelProperty(value = "数据模型")
    private String d;

    @ApiModelProperty(value = "数据模型属性")
    private String p;

    @ApiModelProperty(value = "数据模型名称")
    private String n;

    @ApiModelProperty(value = "数据模型属性数据类型")
    private String t;

    @ApiModelProperty(value = "操作符[OpEnum]")
    private String op;

    @ApiModelProperty(value = "数据模型")
    private String vd;

    @ApiModelProperty(value = "数据模型属性")
    private String vp;

    @ApiModelProperty(value = "值1")
    private String v;

    @ApiModelProperty(value = "值2")
    private String vv;

    @ApiModelProperty(value = "多值")
    private List<String> vs;




    public WhereItemBean(){

    }



    public WhereItemBean(String d,String p,String t,String op, String v,String vv,List<String> vs){
        this.d=d;
        this.p=p;
        this.t=t;
        this.op=op;
        this.v=v;
        this.vv=vv;
        this.vs=vs;
    }


    public WhereItemBean(String d, String p, MetadataStandardTypeEnum t, ConditionOp op, String v){
        this.d=d;
        this.p=p;
        this.t=t.getCode();
        this.op=op.getCode();
        this.v=v;
    }

    public WhereItemBean(String d,String p,String t,String op, String v){
        this.d=d;
        this.p=p;
        this.t=t;
        this.op=op;
        this.v=v;
    }

    public WhereItemBean(String d,String p,String t,String op, String v, String vv){
        this.d=d;
        this.p=p;
        this.t=t;
        this.op=op;
        this.v=v;
        this.vv=vv;
    }

    public WhereItemBean(String d,String p,String t,String op, List<String> vs){
        this.d=d;
        this.p=p;
        this.t=t;
        this.op=op;
        this.vs=vs;
    }



}
