package com.xxh.cloud.metadata.framework.modules.script.sql.operate.script;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.ISqlWrapper;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean.WhereAndOrBean;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.constant.RelAndOrEnum;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean.WhereItemBean;

import java.util.ArrayList;
import java.util.List;

public class WhereWrapper implements ISqlWrapper {

    private List<WhereAndOrBean> where;

    public WhereWrapper(List<WhereAndOrBean> where){
        this.where=where;
    }

    @Override
    public String getSqlSegment() {
        List<String> whereSqlItems=new ArrayList<>();

        if(CollUtil.isNotEmpty(this.where)){
            for(WhereAndOrBean whereBean:this.where){
                if(RelAndOrEnum.Where_And.getCode().equals(whereBean.getAot())){
                    whereSqlItems.add(ConditionWrapper.getSqlSegment(whereBean));
                }else  if(RelAndOrEnum.Where_Or.getCode().equals(whereBean.getAot())){
                    String itemSQL= getWhereOrSql(whereBean.getOr());
                    if(StrUtil.isNotEmpty(itemSQL)){
                        whereSqlItems.add(itemSQL);
                    }
                }
            }
        }

        String _whereSQL= String.join(" and " ,whereSqlItems);

        if(StrUtil.isEmpty(_whereSQL)){
            return "1=1";
        }else {
            return _whereSQL;
        }
    }


    private String getWhereOrSql(List<WhereItemBean> items){
        if(CollUtil.isEmpty(items)){
            return null;
        }
        List<String> sqlItems=new ArrayList<>();
        for(WhereItemBean item:items){
            if(item!=null){
                sqlItems.add(ConditionWrapper.getSqlSegment(item));
            }
        }
        if(sqlItems.size()<=0){
            return null;
        }
        String sql= String.join(" and " ,sqlItems);
        return StrUtil.format("( {} )",sql);
    }


}
