package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准诊断(疾病)关联IDC表
 * </p>
 *
 * @author anros
 * @since 2024-04-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_disease_icd_rel")
public class StandardDiseaseIcdRel extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 疾病ID
     */
     @ApiModelProperty(value = "疾病ID")
      private String diseaseId;

    /**
     * ICD10编号
     */
     @ApiModelProperty(value = "ICD10编号")
      private String icd10Code;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 英文名称
     */
     @ApiModelProperty(value = "英文名称")
      private String enName;

    /**
     * 名称缩写
     */
     @ApiModelProperty(value = "名称缩写")
      private String abbrName;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;






}
