package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准诊断(疾病)表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_disease_info")
public class StandardDiseaseInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编号
     */
     @ApiModelProperty(value = "内部编号")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 诊断名称
     */
     @ApiModelProperty(value = "诊断名称")
      private String name;

    /**
     * 诊断别名
     */
     @ApiModelProperty(value = "诊断别名【优化】")
      private String aliasName;

    /**
     * ICD10编号-DEL
     */
     @ApiModelProperty(value = "ICD10编号【优化】")
      private String icd10Code;

    /**
     * 英文名称-DEL
     */
     @ApiModelProperty(value = "英文名称【优化】")
      private String enName;

    /**
     * 名称缩写-DEL
     */
     @ApiModelProperty(value = "名称缩写【优化】")
      private String abbrName;

    /**
     * 父ID
     */
     @ApiModelProperty(value = "父ID")
      private String pid;

    /**
     * 对应疾病系统
     */
     @ApiModelProperty(value = "对应疾病系统")
      private String systemId;

    /**
     * 类型（多选）
     */
     @ApiModelProperty(value = "类型（多选）【优化】")
      private String type;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号 【优化】")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 状态-显示
     */
     @ApiModelProperty(value = "状态-显示")
      private String showStatus;

    /**
     * 状态-扩展1
     */
     @ApiModelProperty(value = "状态-扩展1")
      private String oneStatus;

    /**
     * 状态-扩展2
     */
     @ApiModelProperty(value = "状态-扩展2")
      private String twoStatus;



    @ApiModelProperty(value = "疾病类型")
    private String diseaseType;

    @ApiModelProperty(value = "是否需要手术治疗【优化】")
    private String operationYn;

    @ApiModelProperty(value = "是否需要住院治疗【优化】")
    private String inHospitalYn;

    @ApiModelProperty(value = "是否需要复诊【优化】")
    private String followUpYn;




}
