package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准疾病系统表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_disease_system_info")
public class StandardDiseaseSystemInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编号
     */
     @ApiModelProperty(value = "内部编号")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 疾病系统名称
     */
     @ApiModelProperty(value = "疾病系统名称")
      private String name;

    /**
     * 疾病系统别名
     */
     @ApiModelProperty(value = "疾病系统别名")
      private String aliasName;

    /**
     * 疾病系统名称英文
     */
     @ApiModelProperty(value = "疾病系统名称英文")
      private String enName;

    /**
     * 疾病系统名称缩写
     */
     @ApiModelProperty(value = "疾病系统名称缩写")
      private String abbrName;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;




}
