package com.xxh.cloud.metadata.framework.modules.standard.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准收费项目信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_fee_project_info")
public class StandardFeeProjectInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 收费类型
     */
     @ApiModelProperty(value = "收费类型")
      private String type;

    /**
     * 收费名称
     */
     @ApiModelProperty(value = "收费名称")
      private String name;

    /**
     * 收费金额
     */
     @ApiModelProperty(value = "收费金额")
      private BigDecimal fund;

    /**
     * 说明
     */
     @ApiModelProperty(value = "说明")
      private String remark;

    /**
     * 收费组套ID
     */
     @ApiModelProperty(value = "收费组套ID")
      private String groupId;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;



}
