package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准检验组套表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_laboratory_group_info")
public class StandardLaboratoryGroupInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编号
     */
     @ApiModelProperty(value = "内部编号")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 组套名称
     */
     @ApiModelProperty(value = "组套名称")
      private String name;

    /**
     * 组套别名
     */
     @ApiModelProperty(value = "组套别名")
      private String aliasName;

    /**
     * 组套分类
     */
     @ApiModelProperty(value = "组套分类")
      private String type;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;




//    /**
//     * 创建者
//     */
//     @ApiModelProperty(value = "创建者")
//      private String creator;
//
//    /**
//     * 创建时间
//     */
//     @ApiModelProperty(value = "创建时间")
//      private Date createDate;
//
//    /**
//     * 更新者
//     */
//     @ApiModelProperty(value = "更新者")
//      private String updater;
//
//    /**
//     * 更新时间
//     */
//     @ApiModelProperty(value = "更新时间")
//      private Date updateDate;


}
