package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准检验项目
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_laboratory_project_info")
public class StandardLaboratoryProjectInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编码
     */
     @ApiModelProperty(value = "内部编码")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 检验名称
     */
     @ApiModelProperty(value = "检验名称")
      private String name;

    /**
     * 检验名称缩写
     */
     @ApiModelProperty(value = "检验名称缩写")
      private String abbrName;

    /**
     * 检验名称别名
     */
     @ApiModelProperty(value = "检验名称别名")
      private String aliasName;

    /**
     * 分类(多)
     */
     @ApiModelProperty(value = "分类(多)")
      private String typeIds;

    /**
     * 样本类型
     */
     @ApiModelProperty(value = "样本类型")
      private String sampleId;

    /**
     * 单位(多)
     */
     @ApiModelProperty(value = "单位(多)")
      private String unitIds;


    @ApiModelProperty(value = "结果数据类型")
     private String resultDataType;


    /**
     * 结果类型
     */
     @ApiModelProperty(value = "结果类型")
      private String resultType;

    /**
     * 参考范围(多)
     */
     @ApiModelProperty(value = "参考范围(多)")
      private String referenceRangeJson;

    /**
     * 危急值(多)
     */
     @ApiModelProperty(value = "危急值(多)")
      private String criticalValueJson;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;


    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;





}
