package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准药物关联医院药品信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_medicant_drug_rel")
public class StandardMedicantDrugRel extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编号
     */
     @ApiModelProperty(value = "内部编号")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 药品ID
     */
     @ApiModelProperty(value = "药品ID")
      private String medicantId;

    /**
     * 院内药品编号
     */
     @ApiModelProperty(value = "院内药品编号")
      private String drugId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
