package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准手术信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_operation_info")
public class StandardOperationInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编码
     */
     @ApiModelProperty(value = "内部编码")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 手术名称
     */
     @ApiModelProperty(value = "手术名称")
      private String name;

    /**
     * 手术部位
     */
     @ApiModelProperty(value = "手术部位")
      private String part;

    /**
     * 是否医保
     */
     @ApiModelProperty(value = "是否医保")
      private String medicalInsurance;

    /**
     * 费用
     */
     @ApiModelProperty(value = "费用")
      private String fee;

    /**
     * 难度
     */
     @ApiModelProperty(value = "难度")
      private String difficulty;

    /**
     * 后遗症
     */
     @ApiModelProperty(value = "后遗症")
      private String sequela;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;




}
