package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 来源信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_source_info")
public class StandardSourceInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 原文内容
     */
     @ApiModelProperty(value = "原文内容")
      private String textContent;

    /**
     * 来源信息
     */
     @ApiModelProperty(value = "来源信息")
      private String sourceContent;

    /**
     * 关联对象分类
     */
     @ApiModelProperty(value = "关联对象分类")
      private String relType;

    /**
     * 关联对象ID
     */
     @ApiModelProperty(value = "关联对象ID")
      private String relId;

    /**
     * 关联对象属性分类
     */
     @ApiModelProperty(value = "关联对象属性分类")
      private String relParam;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;


}
