package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准症状信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_symptom_info")
public class StandardSymptomInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编码
     */
     @ApiModelProperty(value = "内部编码")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 症状名称
     */
     @ApiModelProperty(value = "症状名称")
      private String name;

    /**
     * 症状系统
     */
     @ApiModelProperty(value = "症状系统")
      private String type;

    /**
     * 是否紧急
     */
     @ApiModelProperty(value = "是否紧急")
      private String urgent;

    /**
     * 父ID
     */
     @ApiModelProperty(value = "父ID")
      private String pid;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;




}
