package com.xxh.cloud.metadata.framework.modules.standard.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准化验单位信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_unit_info")
public class StandardUnitInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 内部编号
     */
     @ApiModelProperty(value = "内部编号")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 单位名称
     */
     @ApiModelProperty(value = "单位名称")
      private String name;

    /**
     * 单位解释
     */
     @ApiModelProperty(value = "单位解释")
      private String remark;

    /**
     * 清洗匹配规则
     */
     @ApiModelProperty(value = "清洗匹配规则")
      private String ruleConfig;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 版本号
     */
     @ApiModelProperty(value = "版本号")
      private String versionCode;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
