package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class StandardDiseaseIcdUpdateDTO {

    /**
     * 疾病ID
     */
    @ApiModelProperty(value = "疾病ID", required = true)
    @NotEmpty(message = "疾病ID[diseaseId]不能为空")
    private String diseaseId;

    /**
     * ICD10编号
     */
    @ApiModelProperty(value = "ICD10编号", required = true)
    @NotEmpty(message = "ICD10编号[icd10Code]不能为空")
    private String icd10Code;

    /**
     * 名称
     */
    @ApiModelProperty(value = "名称")
    private String name;

    /**
     * 英文名称
     */
    @ApiModelProperty(value = "英文名称")
    private String enName;

    /**
     * 名称缩写
     */
    @ApiModelProperty(value = "名称缩写")
    private String abbrName;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 项目编号
     */
    @ApiModelProperty(value = "项目编号", required = true)
    @NotEmpty(message = "项目编号[projectCode]不能为空")
    private String projectCode;

}
