package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.Set;

@Getter
@Setter
public class StandardDiseaseUpdateDTO {

    @ApiModelProperty(value = "内部编号",required = true)
    @NotEmpty(message = "内部编号不能为空")
    private String id;



    @ApiModelProperty(value = "诊断名称",required = true)
    @NotEmpty(message = "诊断名称不能为空")
    private String name;


    @ApiModelProperty(value = "诊断别名")
    private String aliasName;


    @ApiModelProperty(value = "ICD10编号")
    private String icd10Code;


    @ApiModelProperty(value = "英文名称")
    private String enName;


    @ApiModelProperty(value = "名称缩写")
    private String abbrName;


    @ApiModelProperty(value = "对应疾病系统")
    private String systemId;


    @ApiModelProperty(value = "类型（多选）")
    private Set<String> type;

    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态-显示(YN)")
    private String showStatus;


    @ApiModelProperty(value = "状态-扩展1(YN)")
    private String oneStatus;


    @ApiModelProperty(value = "状态-扩展2(YN)")
    private String twoStatus;


    @ApiModelProperty(value = "疾病类型")
    private String diseaseType;

    @ApiModelProperty(value = "是否需要手术治疗")
    private String operationYn;

    @ApiModelProperty(value = "是否需要住院治疗")
    private String inHospitalYn;

    @ApiModelProperty(value = "是否需要复诊")
    private String followUpYn;




}
