package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto;

import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.LaboratoryProjectCriticalValueVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.LaboratoryProjectReferenceRangeVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class StandardLaboratoryProjectUpdateDTO {



    @ApiModelProperty(value = "内部编码",required = true)
    @NotEmpty(message = "内部编码不能为空")
    private String id;

    @ApiModelProperty(value = "检验名称",required = true)
    @NotEmpty(message = "检验名称不能为空")
    private String name;

    @ApiModelProperty(value = "检验名称缩写")
    private String abbrName;

    @ApiModelProperty(value = "检验名称别名")
    private String aliasName;

    @ApiModelProperty(value = "分类(多)")
    private List<String> typeIds;


    @ApiModelProperty(value = "样本类型")
    private String sampleId;


    @ApiModelProperty(value = "单位(多)")
    private List<String> unitIds;


    @ApiModelProperty(value = "结果类型")
    private String resultType;

    @ApiModelProperty(value = "结果数据类型")
    private String resultDataType;


    @ApiModelProperty(value = "参考范围(多)")
    private List<LaboratoryProjectReferenceRangeVO> referenceRangeJson;


    @ApiModelProperty(value = "危急值(多)")
    private List<LaboratoryProjectCriticalValueVO> criticalValueJson;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "组套ID(多)")
    private List<String> groupIds;
}
