package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

@Getter
@Setter
public class StandardMedicantUpdateDTO {

    @ApiModelProperty(value = "内部编号",required = true)
    @NotEmpty(message = "内部编号不能为空")
    private String id;

    // @ApiModelProperty(value = "药品编号",required = true)
    // @NotEmpty(message = "药品编号不能为空")
    // private String medicantCode;


    @ApiModelProperty(value = "通用名(GB)",required = true)
    @NotEmpty(message = "通用名不能为空")
    private String standardName;


    @ApiModelProperty(value = "商品名",required = true)
    @NotEmpty(message = "商品名不能为空")
    private String name;

    /**
     * 药品分类
     */
    @ApiModelProperty(value = "药品分类")
    private String category;

    /**
     * 生产企业
     */
    @ApiModelProperty(value = "生产企业")
    private String manufacturer;

    /**
     * 药品性质
     */
    @ApiModelProperty(value = "药品性质")
    private String nature;

    /**
     * 关联疾病
     */
    @ApiModelProperty(value = "关联疾病")
    private String diseaseRelation;

    /**
     * 药品形状
     */
    @ApiModelProperty(value = "药品形状")
    private String shape;

    /**
     * 药品成分
     */
    @ApiModelProperty(value = "药品成分")
    private String composition;

    /**
     * 适应症
     */
    @ApiModelProperty(value = "适应症")
    private String indication;

    /**
     * 规格
     */
    @ApiModelProperty(value = "规格")
    private String specification;

    /**
     * 不良反应
     */
    @ApiModelProperty(value = "不良反应")
    private String adverseReaction;

    /**
     * 用法用量
     */
    @ApiModelProperty(value = "用法用量")
    private String usageuse;

    /**
     * 禁忌
     */
    @ApiModelProperty(value = "禁忌")
    private String contraindication;

    /**
     * 注意事项
     */
    @ApiModelProperty(value = "注意事项")
    private String precautions;

    /**
     * 孕妇及哺乳期妇女用药
     */
    @ApiModelProperty(value = "孕妇及哺乳期妇女用药")
    private String usePregnant;

    /**
     * 儿童用药
     */
    @ApiModelProperty(value = "儿童用药")
    private String useChildren;

    /**
     * 老人用药
     */
    @ApiModelProperty(value = "老人用药")
    private String useOldPeople;

    /**
     * 药物相互作用
     */
    @ApiModelProperty(value = "药物相互作用")
    private String interaction;

    /**
     * 药理毒理
     */
    @ApiModelProperty(value = "药理毒理")
    private String pharmacology;

    /**
     * 药代动力学
     */
    @ApiModelProperty(value = "药代动力学")
    private String pharmacokinetics;

    /**
     * 贮藏
     */
    @ApiModelProperty(value = "贮藏")
    private String storage;

    /**
     * 有效期
     */
    @ApiModelProperty(value = "有效期")
    private String expiryDate;

    /**
     * 单次剂量
     */
    @ApiModelProperty(value = "单次剂量")
    private String oneDoseNum;

    /**
     * 单次剂量单位
     */
    @ApiModelProperty(value = "单次剂量单位")
    private String oneDoseUnit;

    /**
     * 单次用量
     */
    @ApiModelProperty(value = "单次用量")
    private String oneUseNum;

    /**
     * 单次用量单位
     */
    @ApiModelProperty(value = "单次用量单位")
    private String oneUseUnit;

    /**
     * 建议用药频次
     */
    @ApiModelProperty(value = "建议用药频次")
    private String useFrequency;

    /**
     * 建议用药备注
     */
    @ApiModelProperty(value = "建议用药备注")
    private String useRemark;

    /**
     * 版本号
     */
    @ApiModelProperty(value = "版本号")
    private String versionCode;




}
