package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos;


import java.util.Date;
import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class StandardDiseaseFullVO {
    
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "诊断名称")
    private String name;


    @ApiModelProperty(value = "诊断别名")
    private String aliasName;


    @ApiModelProperty(value = "ICD10编号")
    private String icd10Code;


    @ApiModelProperty(value = "英文名称")
    private String enName;

    @ApiModelProperty(value = "名称缩写")
    private String abbrName;


    @ApiModelProperty(value = "对应疾病系统")
    private String systemId;


    @ApiModelProperty(value = "类型（多选）")
    private List<String> type;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    @ApiModelProperty(value = "版本号")
    private String versionCode;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;

    @ApiModelProperty(value = "状态-显示")
    private String showStatus;

    @ApiModelProperty(value = "状态-扩展1")
    private String oneStatus;

    @ApiModelProperty(value = "状态-扩展2")
    private String twoStatus;


    @ApiModelProperty(value = "疾病类型")
    private String diseaseType;

    @ApiModelProperty(value = "是否需要手术治疗")
    private String operationYn;

    @ApiModelProperty(value = "是否需要住院治疗")
    private String inHospitalYn;

    @ApiModelProperty(value = "是否需要复诊")
    private String followUpYn;


    //================================

    @ApiModelProperty(value = "是否有子节点")
    private String isChildFlag;

    @ApiModelProperty(value = "子节点数量")
    private Integer childNum;

    @ApiModelProperty(value = "创建者(姓名)")
    private String creatorName;

    @ApiModelProperty(value = "更新者(姓名)")
    private String updaterName;

    //==================================

    @ApiModelProperty(value = "诊断关联信息")
    List<StandardDiseaseDiagnosisVO> standardDiseaseDiagnosisList;
    
    @ApiModelProperty(value = "ICD关联信息")
    List<StandardDiseaseIcdVO> standardDiseaseIcdList;
}
