package com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos;

import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardLaboratoryTypeBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardSampleBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardUnitBO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class StandardLaboratoryProjectVO {


    @ApiModelProperty(value = "内部编码")
    private String id;

    @ApiModelProperty(value = "检验名称")
    private String name;

    @ApiModelProperty(value = "检验名称缩写")
    private String abbrName;

    @ApiModelProperty(value = "检验名称别名")
    private String aliasName;

    @ApiModelProperty(value = "分类(多)")
    private List<String> typeIds;

    @ApiModelProperty(value = "样本类型")
    private String sampleId;


    @ApiModelProperty(value = "单位(多)")
    private List<String> unitIds;

    @ApiModelProperty(value = "结果数据类型(MetadataStandardTypeEnum)")
    private String resultDataType;

    @ApiModelProperty(value = "结果类型")
    private String resultType;


    @ApiModelProperty(value = "参考范围(多)")
    private List<LaboratoryProjectReferenceRangeVO> referenceRangeJson;

    @ApiModelProperty(value = "危急值(多)")
    private List<LaboratoryProjectCriticalValueVO> criticalValueJson;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "版本号")
    private String versionCode;


     @ApiModelProperty(value = "创建者")
      private String creator;


     @ApiModelProperty(value = "创建时间")
      private Date createDate;


     @ApiModelProperty(value = "更新者")
      private String updater;


     @ApiModelProperty(value = "更新时间")
      private Date updateDate;

     //------------------- change -------------------------

    @ApiModelProperty(value = "分类(多)")
    private List<StandardLaboratoryTypeBO> typeList;

    @ApiModelProperty(value = "样本类型")
    private StandardSampleBO sample;

    @ApiModelProperty(value = "单位(多)")
    private List<StandardUnitBO> unitList;

    @ApiModelProperty(value = "创建者")
    private String creatorName;

    @ApiModelProperty(value = "更新者")
    private String updaterName;


    public void addType(StandardLaboratoryTypeBO item){
        if(this.typeList==null){
            this.typeList=new ArrayList<>();
        }
        if(item!=null){
            this.typeList.add(item);
        }
    }

    public void addUnit(StandardUnitBO item){
        if(this.unitList==null){
            this.unitList=new ArrayList<>();
        }
        if(item!=null){
            this.unitList.add(item);
        }
    }
}
