package com.xxh.cloud.metadata.framework.modules.standardBiz.biz.impl;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.metadata.framework.modules.script.mapper.SqlOperateMapper;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardSourceListDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardSourceQueryDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardSourceSaveDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardSourceUpdateDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSourceVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.biz.StandardSourceBizService;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardSourceInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class StandardSourceBizServiceImpl implements StandardSourceBizService {

    @Autowired
    private StandardSourceInfoService standardSourceInfoService;






    @Override
    public PageData<StandardSourceVO> query(StandardSourceQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public List<StandardSourceVO> list(StandardSourceListDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public StandardSourceVO save(StandardSourceSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public StandardSourceVO update(StandardSourceUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public void delById(String id) {
        if(StrUtil.isEmpty(id)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"ID不能为空");
        }

    }

    @Override
    public StandardSourceVO getById(String id) {
        if(StrUtil.isEmpty(id)){
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR,"ID不能为空");
        }

        return null;
    }


    @Autowired
    private SqlOperateMapper sqlOperateMapper;

    @Override
    public void h1() {

        List<String> typeList=new ArrayList<>();
//        typeList.add("临床表现");
//        typeList.add("手术治疗");
//        typeList.add("实验室检查");
//        typeList.add("就诊科室");
//        typeList.add("病理分型");
//        typeList.add("同义词");
//        typeList.add("影像学检查");
//        typeList.add("药物治疗");
//        typeList.add("辅助检查");
//        typeList.add("高危因素");

//        typeList.add("并发症");
//        typeList.add("病因");
//        typeList.add("风险评估因素");
//        typeList.add("多发季节");
//        typeList.add("发病性别倾向");
//        typeList.add("辅助治疗");
//        typeList.add("发病部位");
//        typeList.add("放射治疗");


//        typeList.add("多发群体");
//        typeList.add("预后状况");
//        typeList.add("发病率");
//        typeList.add("组织学检查");
//        typeList.add("病史");
//        typeList.add("内窥镜检查");
//        typeList.add("发病机制");
//        typeList.add("预防");
//        typeList.add("鉴别诊断");
//        typeList.add("筛查");


        //todo:
//        typeList.add("治疗后症状");
//        typeList.add("化疗");
//        typeList.add("遗传因素");
//        typeList.add("相关（转化）");
//        typeList.add("相关（导致）");
//        typeList.add("发病年龄");
//        typeList.add("阶段");
//        typeList.add("死亡率");
//        typeList.add("预后生存率");
//        typeList.add("多发地区");
//        typeList.add("转移部位");
//        typeList.add("外侵部位");


//        typeList.add("传播途径");
//        typeList.add("无");
//        typeList.add("合并症");
//        typeList.add("分型");

//        for(String type:typeList){
//            this.h1_1(type);
//        }


//        临床表现 X
//        手术治疗 X
//        实验室检查 x
//        同义词 x
//        就诊科室 x
//        病理分型 x
//        影像学检查 x
//        药物治疗 x

//        相关（转化） x
//        发病性别倾向 x
//        发病年龄  x
//        相关（导致） x
//        并发症 x
//        多发季节 x
//        病因 x
//        高危因素 x
//        风险评估因素 x
//        多发群体 x
//        预后状况 x
//        辅助治疗 x
//        发病率 x
//        辅助检查 x
//        发病部位 x
//        组织学检查 x
//        病史 x
//        内窥镜检查 x
//        发病机制 x
//        预防 x
//        鉴别诊断 x
//        筛查 x
//        治疗后症状 x
//        化疗 x
//        遗传因素 x
//        放射治疗 x
//        阶段 x
//        死亡率 x
//        预后生存率 x
//        多发地区 x
//        转移部位 x
//        相关（症状）
//        外侵部位 x
//        传播途径 x
//        无 x
//         合并症 x
//        分型 x
//



    }


    private void h1_1(String type){
        List<Map<String,Object>> list= sqlOperateMapper.selectList("SELECT name ,rel_name ,rel_info FROM cpubmed_rel_info" +
                " where rel_name='"+type+"'");

        for(Map<String,Object> item:list){
            String name= Convert.toStr(item.get("name"));
            String rel_name= Convert.toStr(item.get("rel_name"));
            String rel_info= Convert.toStr(item.get("rel_info"));
            String[] rels= rel_info.split(",");


            StringBuffer sql1=new StringBuffer();
            sql1.append(" INSERT INTO cpumed_entity_rel_info(d_name,type_name,entity_name) VALUES ");

            for(String relVal:rels){

                String relVal2= relVal.replace("'","\\'");

                //todo:1
//                String sql=StrUtil.format("INSERT INTO cpumed_entity_rel_info(d_name,type_name,entity_name)VALUES ('{}','{}','{}');",
//                        name ,rel_name,relVal2);
//                System.out.println(sql);
//                sqlOperateMapper.dynamicsInsert(sql);


                //todo:2
                String sql2=StrUtil.format(" ('{}','{}','{}'),",name ,rel_name,relVal2);
                sql1.append(sql2);

            }

            String sql3= sql1.substring(0,sql1.length()-1);
            String sql4=  sql3+";";
            System.out.println(sql4);
            sqlOperateMapper.dynamicsInsert(sql4);
        }
    }


}
