package com.xxh.cloud.metadata.framework.modules.standardBiz.biz.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardTherapyListDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardTherapyQueryDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardTherapySaveDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.StandardTherapyUpdateDTO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardTherapyVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.biz.StandardTherapyBizService;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardTherapyInfo;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardTherapyInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StandardTherapyBizServiceImpl implements StandardTherapyBizService {

    @Autowired
    private StandardTherapyInfoService standardTherapyInfoService;


    @Override
    public IPage<StandardTherapyInfo> queryStandardTherapy(StandardTherapyQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        IPage<StandardTherapyInfo> page = standardTherapyInfoService.page(new Page<>(params.getPage(), params.getRows()),
                new QueryWrapper<StandardTherapyInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                        .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                        .eq(StrUtil.isNotEmpty(params.getProjectCode()),"project_code",params.getProjectCode())
                        .eq(StrUtil.isNotEmpty(params.getVersionCode()),"version_code",params.getVersionCode())
                        .like(StrUtil.isNotEmpty(params.getKeywords()),"name",params.getKeywords())
        );
        return page;
    }

    @Override
    public PageData<StandardTherapyVO> query(StandardTherapyQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public List<StandardTherapyVO> list(StandardTherapyListDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public StandardTherapyVO save(StandardTherapySaveDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public StandardTherapyVO update(StandardTherapyUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        return null;
    }

    @Override
    public StandardTherapyVO getById(String id) {
        return null;
    }

    @Override
    public void delById(String id) {

    }
}
