package com.xxh.cloud.metadata.framework.modules.standardBiz.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseDiagnosisVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseFullVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseIcdVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseInfo;

import java.util.List;
import java.util.Map;

public class StandardDiseaseConvert {

    public static StandardDiseaseVO getStandardDiseaseVO(StandardDiseaseInfo entity){
        StandardDiseaseVO data=new StandardDiseaseVO();
        BeanUtil.copyProperties(entity,data,"type");
        if(StrUtil.isNotEmpty(entity.getType())){
            data.setType(StrJoinSplitUtils.split2List(entity.getType()));
        }
        return data;
    }

    public static StandardDiseaseVO getStandardDiseaseVO(StandardDiseaseInfo entity, Map<String, AdminUserBO> userMap){
        StandardDiseaseVO data = StandardDiseaseConvert.getStandardDiseaseVO(entity);
        if (CollUtil.isNotEmpty(userMap)) {
            AdminUserBO creatorName = userMap.get(data.getCreator());
            AdminUserBO updaterName = userMap.get(data.getUpdater());

            if (null != creatorName) {
                data.setCreatorName(creatorName.getRealName());
            }
            if (null != updaterName) {
                data.setUpdaterName(updaterName.getRealName());
            }
        }
        return data;
    }


    public static StandardDiseaseVO getStandardDiseaseVO(StandardDiseaseInfo entity, Map<String,Integer> childIdNumMap, Map<String, AdminUserBO> userMap){
        StandardDiseaseVO data=StandardDiseaseConvert.getStandardDiseaseVO(entity, userMap);
        if(MapUtil.isNotEmpty(childIdNumMap)){
            if(childIdNumMap.containsKey(data.getId())){
                Integer num= childIdNumMap.get(data.getId());
                data.setIsChildFlag(YN.YES.getCode());
                data.setChildNum(num);
            }else {
                data.setIsChildFlag(YN.NO.getCode());
            }
        }
        return data;
    }

    public static StandardDiseaseFullVO getStandardDiseaseFullVO(StandardDiseaseVO vo, List<StandardDiseaseIcdVO> standardDiseaseIcdList, List<StandardDiseaseDiagnosisVO> standardDiseaseDiagnosisList){
        if (null == vo) {
            return null;
        }
        StandardDiseaseFullVO data = new StandardDiseaseFullVO();
        BeanUtil.copyProperties(vo,data);

        data.setStandardDiseaseDiagnosisList(standardDiseaseDiagnosisList);
        data.setStandardDiseaseIcdList(standardDiseaseIcdList);
        return data;
    }

}
