package com.xxh.cloud.metadata.framework.modules.standardBiz.helper;

import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseDiagnosisRel;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseIcdRel;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseDiagnosisVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseIcdVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardDiseaseVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import cn.hutool.core.collection.CollUtil;

import java.util.Map;

public class StandardDiseaseDiagnosisConvert {

    public static StandardDiseaseDiagnosisVO getStandardDiseaseDiagnosisVO(StandardDiseaseDiagnosisRel entity) {
        if (null == entity) {
            return null;
        }
        StandardDiseaseDiagnosisVO vo = new StandardDiseaseDiagnosisVO();
        vo.setId(entity.getId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setObjId(entity.getObjId());
        vo.setObjName(entity.getObjName());
        vo.setObjType(entity.getObjType());
        vo.setProjectCode(entity.getProjectCode());
        vo.setRemark(entity.getRemark());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static StandardDiseaseDiagnosisVO getStandardDiseaseDiagnosisVO(StandardDiseaseDiagnosisRel entity,
                                                                           Map<String, StandardDiseaseVO> diseaseMap,
                                                                           Map<String, AdminUserBO> userMap){
        StandardDiseaseDiagnosisVO vo = getStandardDiseaseDiagnosisVO(entity);
        if (null != vo) {
            if (CollUtil.isNotEmpty(diseaseMap)) {
                vo.setStandardDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));
            }
            if (CollUtil.isNotEmpty(userMap)) {
                AdminUserBO creatorName = userMap.get(vo.getCreator());
                AdminUserBO updaterName = userMap.get(vo.getUpdater());

                if (null != creatorName) {
                    vo.setCreatorName(creatorName.getRealName());
                }
                if (null != updaterName) {
                    vo.setUpdaterName(updaterName.getRealName());
                }
            }
        }
        return vo;
    }

    
    public static StandardDiseaseIcdVO getStandardDiseaseIcdVO(StandardDiseaseIcdRel entity) {
        if (null == entity) {
            return null;
        }
        StandardDiseaseIcdVO vo = new StandardDiseaseIcdVO();
        vo.setId(entity.getId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setIcd10Code(entity.getIcd10Code());
        vo.setName(entity.getName());
        vo.setEnName(entity.getEnName());
        vo.setAbbrName(entity.getAbbrName());
        vo.setProjectCode(entity.getProjectCode());
        vo.setRemark(entity.getRemark());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static StandardDiseaseIcdVO getStandardDiseaseIcdVO(StandardDiseaseIcdRel entity,
                                                                Map<String, StandardDiseaseVO> diseaseMap,
                                                                Map<String, AdminUserBO> userMap){
        StandardDiseaseIcdVO vo = getStandardDiseaseIcdVO(entity);
        if (null != vo) {
            if (CollUtil.isNotEmpty(diseaseMap)) {
                vo.setStandardDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));
            }
            if (CollUtil.isNotEmpty(userMap)) {
                AdminUserBO creatorName = userMap.get(vo.getCreator());
                AdminUserBO updaterName = userMap.get(vo.getUpdater());

                if (null != creatorName) {
                    vo.setCreatorName(creatorName.getRealName());
                }
                if (null != updaterName) {
                    vo.setUpdaterName(updaterName.getRealName());
                }
            }
        }
        return vo;
    }


}
