package com.xxh.cloud.metadata.framework.modules.standardBiz.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardLaboratoryTypeBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardSampleBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardUnitBO;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryGroupInfo;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryProjectInfo;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryRelationInfo;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardLaboratoryTypeInfo;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryGroupVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryProjectVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardLaboratoryTypeVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class StandardLaboratoryConvert {
    /**
     *
     * */
    public static StandardLaboratoryGroupVO getStandardLaboratoryGroupVO(StandardLaboratoryGroupInfo entity){
        StandardLaboratoryGroupVO data=new StandardLaboratoryGroupVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }


    /**
     *
     * */
    public static StandardLaboratoryProjectVO getStandardLaboratoryProjectVO(StandardLaboratoryProjectInfo entity){
        StandardLaboratoryProjectVO data=new StandardLaboratoryProjectVO();
        BeanUtil.copyProperties(entity,data,"typeIds","unitIds","referenceRangeJson","criticalValueJson");

        if(StrUtil.isNotEmpty(entity.getTypeIds())){
            data.setTypeIds(StrJoinSplitUtils.split2List(entity.getTypeIds()));
        }

        if(StrUtil.isNotEmpty(entity.getUnitIds())){
            data.setUnitIds(StrJoinSplitUtils.split2List(entity.getUnitIds()));
        }

//        if(StrUtil.isNotEmpty(entity.getReferenceRangeJson())){
//            data.setReferenceRangeJson(JSON.parseArray(entity.getReferenceRangeJson(), LaboratoryProjectReferenceRangeVO.class));
//        }
//        if(StrUtil.isNotEmpty(entity.getCriticalValueJson())){
//            data.setCriticalValueJson(JSON.parseArray(entity.getCriticalValueJson(), LaboratoryProjectCriticalValueVO.class));
//        }
        return data;
    }

    /**
     *
     * */
    public static StandardLaboratoryProjectVO getStandardLaboratoryProjectVO(StandardLaboratoryProjectInfo entity,
                                                                             Map<String, StandardLaboratoryTypeBO> laboratoryTypeMap,
                                                                             Map<String, StandardUnitBO> unitMap,
                                                                             Map<String, StandardSampleBO> sampleMap,
                                                                             Map<String, AdminUserBO> userMap){
        StandardLaboratoryProjectVO data=getStandardLaboratoryProjectVO(entity);

        if(MapUtil.isNotEmpty(laboratoryTypeMap) && CollUtil.isNotEmpty(data.getTypeIds())){
            data.getTypeIds().forEach(id->{
                data.addType(laboratoryTypeMap.get(id));
            });
        }

        if(MapUtil.isNotEmpty(unitMap) && CollUtil.isNotEmpty(data.getUnitIds())){
            data.getUnitIds().forEach(id->{
                data.addUnit(unitMap.get(id));
            });
        }
        if(MapUtil.isNotEmpty(sampleMap) && StrUtil.isNotEmpty(data.getSampleId())){
            data.setSample(sampleMap.get(data.getSampleId()));
        }

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user =  userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getUserName());
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user =  userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getUserName());
            }
        }

        return data;
    }

    /**
     *
     * */
    public static StandardLaboratoryTypeVO getStandardLaboratoryTypeVO(StandardLaboratoryTypeInfo entity){
        StandardLaboratoryTypeVO data=new StandardLaboratoryTypeVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }



    /**
     * add
     * */
    public static StandardLaboratoryRelationInfo getStandardLaboratoryRelation_Add(String groupId,String projectId){
        StandardLaboratoryRelationInfo entity=new StandardLaboratoryRelationInfo();
        entity.setId(IdUtil.getSnowflake(3,1).nextIdStr());
        entity.setGroupId(groupId);
        entity.setProjectId(projectId);
        return entity;
    }



}
