package com.xxh.cloud.metadata.framework.modules.tableData.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Map;

@Getter
@Setter
public class TableDataSaveDTO {

    @ApiModelProperty(value = "表编号",required = true)
    @NotEmpty(message = "表编号不能为空")
    private String tableId;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    @ApiModelProperty(value = "版本号")
    private String versionCode;

    @ApiModelProperty(value = "对象分类")
    private String objectType;

    @ApiModelProperty(value = "对象ID")
    private String objectId;


    @ApiModelProperty(value = "表数据",required = true)
    @NotNull(message = "表数据不能为空")
    private Map<String, String> data;



}
