package com.xxh.cloud.metadata.framework.modules.tableData.biz.impl;

import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableColumnVO;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableInfoVO;
import com.xxh.cloud.metadata.framework.modules.cache.service.TableInfoCacheService;
import com.xxh.cloud.metadata.framework.modules.script.bean.dto.EntityOperateGetByIdDTO;
import com.xxh.cloud.metadata.framework.modules.script.service.EntityOperateApiService;
import com.xxh.cloud.metadata.framework.modules.script.sql.operate.bean.SelectBean;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.dto.TableDataGetDTO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataOne2TableVO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataVO;
import com.xxh.cloud.metadata.framework.modules.tableData.biz.Table2DataApiService;
import com.xxh.cloud.metadata.framework.modules.tableData.biz.TableDataGetService;
import com.xxh.cloud.metadata.framework.modules.tableData.helper.TableDataConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class TableDataGetServiceImpl implements TableDataGetService {

    @Autowired
    private EntityOperateApiService entityOperateApiService;
    @Autowired
    private Table2DataApiService table2DataApiService;

    @Override
    public TableDataVO getById(TableDataGetDTO params) {
        ValidatorUtils.validateEntity(params);
        TableInfoVO tableInfo= table2DataApiService.getTableInfoVO(params.getTableId());
        Map<String, TableColumnVO> tableColumnMap= table2DataApiService.getTableColumnList(tableInfo,true);
        Map<String,Object> data=this._get(tableColumnMap,params);
        return  TableDataConvert.getTableDataVO(data);
    }

    @Override
    public TableDataOne2TableVO get2TableById(TableDataGetDTO params) {
        ValidatorUtils.validateEntity(params);
        TableInfoVO tableInfo= table2DataApiService.getTableInfoVO(params.getTableId());
        Map<String, TableColumnVO> tableColumnMap= table2DataApiService.getTableColumnList(tableInfo,true);
        Map<String,Object> data=this._get(tableColumnMap,params);
        TableDataVO data2= TableDataConvert.getTableDataVO(data);
        return TableDataConvert.getTableDataOne2TableVO(tableInfo,data2);
    }

    @Override
    public Map<String, Object> getMapById(TableDataGetDTO params) {
        ValidatorUtils.validateEntity(params);
        TableInfoVO tableInfo= table2DataApiService.getTableInfoVO(params.getTableId());
        Map<String, TableColumnVO> tableColumnMap= table2DataApiService.getTableColumnList(tableInfo,true);
        Map<String, Object> data=this._get(tableColumnMap,params);
        return data;
    }

    private Map<String, Object> _get(Map<String, TableColumnVO> tableColumnMap,TableDataGetDTO params){
        EntityOperateGetByIdDTO getByIdDTO=new EntityOperateGetByIdDTO();
        getByIdDTO.setTableCode(params.getTableId());
        getByIdDTO.setId(params.getId());

        List<SelectBean> select=new ArrayList<>();
        tableColumnMap.forEach((key,item)->{
            select.add(new SelectBean(params.getTableId(),item.getCode(),item.getType()));
        });
        getByIdDTO.setSelect(select);
        Map<String,Object> data= entityOperateApiService.getById(getByIdDTO);
        return data;
    }



}
