package com.xxh.cloud.metadata.framework.modules.tableData.biz.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.TableColumnInfo;
import com.xxh.cloud.metadata.framework.modules.base.service.TableColumnInfoService;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.metadata.framework.modules.constant.TableBaseEnum;
import com.xxh.cloud.metadata.framework.modules.script.bean.dto.EntityDDLAlterDTO;
import com.xxh.cloud.metadata.framework.modules.script.service.EntityDDLApiService;
import com.xxh.cloud.metadata.framework.modules.script.bean.dto.EntityDDLCreatePropertyDTO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.dto.*;
import com.xxh.cloud.metadata.framework.modules.tableData.biz.TableGenerateBizService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Log4j2
@Service
public class TableGenerateBizServiceImpl implements TableGenerateBizService {

    @Autowired
    private EntityDDLApiService entityDDLApiService;
    @Autowired
    private TableColumnInfoService tableColumnInfoService;


    @Override
    public void create2AlterEntityByTable(EntityCreate2AlterByTableDTO params) {
        ValidatorUtils.validateEntity(params);

        List<TableColumnInfo> list= tableColumnInfoService.list(
                new QueryWrapper<TableColumnInfo>()
                        .eq("table_id",params.getTableCode())
        );

        if(CollUtil.isEmpty(list)){
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }

        EntityDDLAlterDTO create2AlterParam=new EntityDDLAlterDTO();
        create2AlterParam.setDataSourceType(params.getDataSourceType());
        create2AlterParam.setDatabase(params.getDatabase());
        create2AlterParam.setTableCode(params.getTableCode());
        create2AlterParam.setTableName(params.getTableName());
        list.forEach(item->{
            create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(item.getCode(),item.getName(), item.getType()));
        });
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.ID,48, YN.YES));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.ObjectType));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.ObjectId));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.ProjectCode));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.VersionCode));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.Creator));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.CreateDate));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.Updater));
        create2AlterParam.addProp(new EntityDDLCreatePropertyDTO(TableBaseEnum.UpdateDate));
        entityDDLApiService.alter(create2AlterParam);
    }





}
