package com.xxh.cloud.metadata.framework.modules.tableData.helper;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.map.MapUtil;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableColumnVO;
import com.xxh.cloud.metadata.framework.modules.base.entity.vos.TableInfoVO;
import com.xxh.cloud.metadata.framework.modules.constant.TableBaseEnum;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataList2TableVO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataOne2TableVO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataPage2TableVO;
import com.xxh.cloud.metadata.framework.modules.tableData.bean.vos.TableDataVO;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;
import java.util.Map;

public class TableDataConvert {


    public static TableDataVO getTableDataVO(Map<String,Object> entity){
        TableDataVO data=new TableDataVO();
        if(MapUtil.isNotEmpty(entity)){
            data.setId(Convert.toStr(entity.get(TableBaseEnum.ID.getCode())));
            data.setProjectCode(Convert.toStr(entity.get(TableBaseEnum.ProjectCode.getCode())));
            data.setVersionCode(Convert.toStr(entity.get(TableBaseEnum.VersionCode.getCode())));
            data.setCreator(Convert.toStr(entity.get(TableBaseEnum.Creator.getCode())));
            data.setCreateDate(Convert.toDate(entity.get(TableBaseEnum.CreateDate.getCode())));
            data.setUpdater(Convert.toStr(entity.get(TableBaseEnum.Updater.getCode())));
            data.setUpdateDate(Convert.toDate(entity.get(TableBaseEnum.UpdateDate.getCode())));
            data.setData(entity);
        }
        return data;
    }



    /**
     *
     * */
    public static TableDataPage2TableVO getTableDataPage2TableVO(TableInfoVO tableInfo, PageData<TableDataVO> data){
        TableDataPage2TableVO resultData=new TableDataPage2TableVO();
        resultData.setTableId(tableInfo.getId());
        resultData.setTableCategoryId(tableInfo.getCategoryId());
        resultData.setTableName(tableInfo.getName());
        resultData.setTableAliasName(tableInfo.getAliasName());
        resultData.setTableCols(tableInfo.getCols());
        resultData.setData(data);
        return resultData;
    }

    /**
     *
     * */
    public static TableDataList2TableVO getTableDataList2TableVO(TableInfoVO tableInfo, List<TableDataVO> data){
        TableDataList2TableVO resultData=new TableDataList2TableVO();
        resultData.setTableId(tableInfo.getId());
        resultData.setTableCategoryId(tableInfo.getCategoryId());
        resultData.setTableName(tableInfo.getName());
        resultData.setTableAliasName(tableInfo.getAliasName());
        resultData.setTableCols(tableInfo.getCols());
        resultData.setData(data);
        return resultData;
    }

    /**
     *
     * */
    public static TableDataOne2TableVO getTableDataOne2TableVO(TableInfoVO tableInfo, TableDataVO data){
        TableDataOne2TableVO  resultData=new TableDataOne2TableVO();
        resultData.setTableId(tableInfo.getId());
        resultData.setTableCategoryId(tableInfo.getCategoryId());
        resultData.setTableName(tableInfo.getName());
        resultData.setTableAliasName(tableInfo.getAliasName());
        resultData.setTableCols(tableInfo.getCols());
        resultData.setData(data);
        return resultData;
    }



}
